/*
 * Copyright 2022 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _CLOCK_CONFIG_H_
#define _CLOCK_CONFIG_H_

#include "fsl_common.h"

/*******************************************************************************
 * Definitions
 ******************************************************************************/
#define BOARD_XTAL0_CLK_HZ                         12000000U  /*!< Board xtal0 frequency in Hz */
#define BOARD_XTAL32K_CLK_HZ                          32768U  /*!< Board xtal32K frequency in Hz */

/*******************************************************************************
 ************************ BOARD_InitBootClocks function ************************
 ******************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus*/

/*!
 * @brief This function executes default configuration of clocks.
 *
 */
void BOARD_InitBootClocks(void);

#if defined(__cplusplus)
}
#endif /* __cplusplus*/

/*******************************************************************************
 ********************** Configuration BOARD_BootClockRUN ***********************
 ******************************************************************************/
/*******************************************************************************
 * Definitions for BOARD_BootClockRUN configuration
 ******************************************************************************/
#define BOARD_BOOTCLOCKRUN_CORE_CLOCK              30000000U  /*!< Core clock frequency: 30000000Hz */


/* Clock outputs (values are in Hz): */
#define BOARD_BOOTCLOCKRUN_ADC_CLOCK                  0UL            /* Clock consumers of ADC_clock output : ADC0 */
#define BOARD_BOOTCLOCKRUN_CLKOUT_CLOCK               0UL            /* Clock consumers of CLKOUT_clock output : N/A */
#define BOARD_BOOTCLOCKRUN_FROHF_CLOCK                60000000UL     /* Clock consumers of FROHF_clock output : N/A */
#define BOARD_BOOTCLOCKRUN_I2C0_CLOCK                 0UL            /* Clock consumers of I2C0_clock output : I2C0 */
#define BOARD_BOOTCLOCKRUN_I3C_FCLK_CLOCK             0UL            /* Clock consumers of I3C_FCLK_clock output : I3C0 */
#define BOARD_BOOTCLOCKRUN_I3C_SLOW_TC_CLOCK          0UL            /* Clock consumers of I3C_SLOW_TC_clock output : I3C0 */
#define BOARD_BOOTCLOCKRUN_I3C_SLOW_CLOCK             0UL            /* Clock consumers of I3C_SLOW_clock output : I3C0 */
#define BOARD_BOOTCLOCKRUN_IOCON0_CLOCK               0UL            /* Clock consumers of IOCON0_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_IOCON1_CLOCK               0UL            /* Clock consumers of IOCON1_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_IOCON2_CLOCK               0UL            /* Clock consumers of IOCON2_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_IOCON3_CLOCK               0UL            /* Clock consumers of IOCON3_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_IOCON4_CLOCK               0UL            /* Clock consumers of IOCON4_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_IOCON5_CLOCK               0UL            /* Clock consumers of IOCON5_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_IOCON6_CLOCK               0UL            /* Clock consumers of IOCON6_clock output : IOCON */
#define BOARD_BOOTCLOCKRUN_LOWPOWER_CLOCK             0UL            /* Clock consumers of LowPower_clock output : WWDT */
#define BOARD_BOOTCLOCKRUN_SPI0_CLOCK                 0UL            /* Clock consumers of SPI0_clock output : SPI0 */
#define BOARD_BOOTCLOCKRUN_SPI1_CLOCK                 0UL            /* Clock consumers of SPI1_clock output : SPI1 */
#define BOARD_BOOTCLOCKRUN_SYSPLL_CLOCK               0UL            /* Clock consumers of SYSPLL_clock output : N/A */
#define BOARD_BOOTCLOCKRUN_SYSTEM_CLOCK               30000000UL     /* Clock consumers of System_clock output : ACOMP, ADC0, CRC, DMA0, FTM0, FTM1, GPIO, I2C0, I3C0, INPUTMUX, IOCON, MRT0, PINT, SPI0, SPI1, SWM0, USART0, USART1, USART2, WKT, WWDT */
#define BOARD_BOOTCLOCKRUN_UART0_CLOCK                0UL            /* Clock consumers of UART0_clock output : USART0 */
#define BOARD_BOOTCLOCKRUN_UART1_CLOCK                0UL            /* Clock consumers of UART1_clock output : USART1 */
#define BOARD_BOOTCLOCKRUN_UART2_CLOCK                0UL            /* Clock consumers of UART2_clock output : USART2 */
#define BOARD_BOOTCLOCKRUN_ULPOSC_CLOCK               0UL            /* Clock consumers of ULPOSC_clock output : WKT */
#define BOARD_BOOTCLOCKRUN_WKTCLKIN_CLOCK             0UL            /* Clock consumers of WKTCLKIN_clock output : WKT */
#define BOARD_BOOTCLOCKRUN_WKT_CLOCK                  30000000UL     /* Clock consumers of WKT_clock output : WKT */

/*******************************************************************************
 * API for BOARD_BootClockRUN configuration
 ******************************************************************************/
#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus*/

/*!
 * @brief This function executes configuration of clocks.
 *
 */
void BOARD_BootClockRUN(void);

#if defined(__cplusplus)
}
#endif /* __cplusplus*/

#endif /* _CLOCK_CONFIG_H_ */

